#!/bin/sh

DIR=$1

MACRO=ARRAY_SIZE

#  First, grep for the most common variants, if you want.  In order,
# these are:

#  sizeof(blah)/sizeof(blah[0])
#  sizeof blah / sizeof blah[0]
#  sizeof(blah)/sizeof(*blah)
#  sizeof blah / sizeof *blah

# grep -Er "sizeof ?\( ?([^\) ]+) ?\) ?/ ?sizeof ?\( ?\1\[0\] ?\)" ${DIR}
# grep -Er "sizeof +([^ \(\)]+) +/ +sizeof +\1\[0\]" ${DIR}
# grep -Er "sizeof ?\( ?([^\) ]+) ?\) ?/ ?sizeof ?\( ?\*\1 ?\)" ${DIR}
# grep -Er "sizeof +([^/\) ]+) */ *sizeof +\*\1" ${DIR}

#  Deal with sizeof(blah)/sizeof(blah[0])

for f in $(grep -Erl "sizeof ?\( ?([^\) ]+) ?\) ?/ ?sizeof ?\( ?\1\[0\] ?\)" ${DIR}) ; do
  echo "${MACRO}()ing $f ..."
  perl -pi -e "s|sizeof ?\( ?([^\) ]+) ?\) ?/ ?sizeof ?\( ?\1\[0\] ?\)|${MACRO}\(\1\)|" $f
done

#  Deal with sizeof blah / sizeof blah[0]

for f in $(grep -Erl "sizeof +([^ \(\)]+) +/ +sizeof +\1\[0\]" ${DIR}) ; do
  echo "${MACRO}()ing $f ..."
  perl -pi -e "s|sizeof +([^\(\) ]+) +/ +sizeof +\1\[0\]|${MACRO}\(\1\)|" $f
done

#  Deal with sizeof(blah)/sizeof(*blah)

for f in $(grep -Erl "sizeof ?\( ?([^\) ]+) ?\) ?/ ?sizeof ?\( ?\*\1 ?\)" ${DIR}) ; do
  echo "${MACRO}()ing $f ..."
  perl -pi -e "s|sizeof ?\( ?([^\) ]+) ?\) ?/ ?sizeof ?\( ?\*\1 ?\)|${MACRO}\(\1\)|" $f
done

#  Deal with sizeof blah / sizeof *blah

for f in $(grep -Erl "sizeof +([^/\) ]+) */ *sizeof +\*\1" ${DIR}) ; do
  echo "${MACRO}()ing $f ..."
  perl -pi -e "s|sizeof +([^/\) ]+) */ *sizeof +\*\1|${MACRO}\(\1\)|" $f
done
